// Seven Segment


unsigned char SevenSegmentDigi[] = { 8, 9, 10, 11};

unsigned char number_table[10] = {
    0b11000000 , //0
    0b11111001 , //1
    0b10100100 , //2
    0b10110000 , //3
    0b10011001 , //4
    0b10010010 , //5
    0b10000010 , //6
    0b11111000 , //7
    0b10000000 , //8
    0b10010000   //9
};

void init_SevenSegment(void)
{
  for(int i=0; i<13; i++)
       pinMode(i, OUTPUT);
}

void sevenSegment( byte val, byte dp )
{
    PORTD = number_table[val];
    
    if (dp == ON) {
       PORTD ^= 0b10000000;  //dp
        dp_count++;
    } else if (dp == BLINK ) {
        PORTD = 0b11111111;
        dp_count++;
    }
    
}

void ControlSegmentDigi( byte val)
{
  for (int i=0; i<4 ;i++)
     if (val != i)
       digitalWrite(SevenSegmentDigi[i],HIGH);  
  
  digitalWrite(SevenSegmentDigi[val],LOW);    
  delay(2);
}
