//unsigned char SevenSegmentpins[] = { 0, 1, 2, 3, 4, 5, 6, 7 }; // an array of pin numbers
unsigned char SevenSegmentDigi[] = { 8, 9, 10, 11};

unsigned char number_table[10] = {
    0b11000000 , //0
    0b11111001 , //1
    0b10100100 , //2
    0b10110000 , //3
    0b10011001 , //4
    0b10010010 , //5
    0b10000010 , //6
    0b11111000 , //7
    0b10000000 , //8
    0b10010000   //9
};

/*unsigned char font_table[10][8] = {
  {0,0,0,0,0,0,1,1}, //0
  {1,0,0,1,1,1,1,1}, //1
  {0,0,1,0,0,1,0,1}, //2
  {0,0,0,0,1,1,0,1}, //3
  {1,0,0,1,1,0,0,1}, //4
  {0,1,0,0,1,0,0,1}, //5
  {0,1,0,0,0,0,0,1}, //6
  {0,0,0,1,1,1,1,1}, //7 
  {0,0,0,0,0,0,0,1}, //8
  {0,0,0,0,1,0,0,1} //9  
};*/



void setup(void)
{
  initSevenSegment();
}


void loop(void)
{
  
  for (int i=0;i<9999;i++)  
  {
    byte digi1 = i /1000;
    byte digi2 = (i - (digi1*1000))/100;
    byte digi3 = (i - (digi1*1000) - (digi2*100) ) /10 ;
    byte digi4 = (i - (digi1*1000) - (digi2*100) - (digi3*10) ) % 10;
    
    sevenSegment(digi1);
    ControlSegmentDigi(0);

    sevenSegment(digi2);
    ControlSegmentDigi(1);
  
    sevenSegment(digi3);
    ControlSegmentDigi(2);

    sevenSegment(digi4);
    ControlSegmentDigi(3); 
  
  }

}

void initSevenSegment(void)
{
  for(int i=0; i<13; i++)
       pinMode(i, OUTPUT);
}

void sevenSegment( byte val)
{
  //for (int i=0; i<8; i++)
  //   digitalWrite(SevenSegmentpins[i], font_table[val][i]); 
  
  PORTD = number_table[val];  
       
}

void ControlSegmentDigi( byte val)
{
  for (int i=0; i<4 ;i++)
     if (val != i)
       digitalWrite(SevenSegmentDigi[i],HIGH);  
  
  digitalWrite(SevenSegmentDigi[val],LOW);    
  delay(2);
}
